mod client;
mod config;
mod error;
mod http;
mod racert;
mod server;
#[cfg(feature = "occlum")]
mod utils;

#[cfg(feature = "occlum")]
mod ioctl;

#[cfg(feature = "occlum")]
mod bindings;
pub mod prelude;
#[cfg(feature = "occlum")]
mod quote;

#[allow(dead_code)]
#[cfg(feature = "occlum")]
mod sgx_consts;

#[cfg(feature = "sealing")]
mod sealing;

pub use crate::config::RaTlsConfig;
#[cfg(feature = "sealing")]
pub use crate::sealing::SgxSealing;

#[cfg(feature = "occlum")]
pub use crate::config::InstanceMeasurement;

pub use crate::error::SgxError;

#[cfg(feature = "actix-web")]
pub use crate::http::actix_web;

#[cfg(feature = "reqwest")]
pub use crate::http::reqwest;

pub trait RaTlsConfigBuilder<T> {
    fn from_ratls_config(config: RaTlsConfig) -> Result<T, SgxError>;
}
