use pbkdf2::pbkdf2_hmac_array;
use sha2::Sha256;

use super::SgxSealing;
use crate::SgxError;

pub type SealingKey256BitDerived = [u8; 32];

impl SgxSealing {
    pub fn get_aes256_sealing_key(self) -> Result<SealingKey256BitDerived, SgxError> {
        let mrsigner_for_salt = Self::get_current_sgx_quote()?.mrsigner().m;

        Ok(pbkdf2_hmac_array::<Sha256, 32>(
            &self.sealing_key,
            &mrsigner_for_salt,
            25519,
        ))
    }
}
